/***********************************************/
/*                                             */
/* CAN-Test    Empfang                         */
/*                                             */
/* 18.07.2003                                  */
/* K.-U. Mrkor                                 */
/*                                             */
/***********************************************/

#include <stdio.h>
#include <regc515c.h>
#include <stub.h>

#include "can.h"

struct CAN_MSG  xdata CanBotschaft;               /* sind immerhin 13 Bytes */

/************************************************/
/* MAIN-Routine									*/
/************************************************/
void AksenMain(void)
{

    lcd_puts("CAN-Init");
    CanInit();
    lcd_setxy(1,0);
    lcd_puts("erfolgt");

    do
    {
        /* Empfangspuffer ueberpruefen und gegebenfalls leeren */
        if ( CanEmpfang( &CanBotschaft)==TRUE)
        {
            /* LCD loeschen*/
            lcd_cls();

            /* Uebergebenen Wert ausgeben */
            lcd_setxy(0,0);
            lcd_puts("w1: ");
            lcd_ubyte(CanBotschaft.Puffer[0]);

            lcd_setxy(0,9);
            lcd_puts("Anz.: ");
            lcd_ubyte(CanBotschaft.DatenLaenge);

            lcd_setxy(1,0);
            /* Adresse ausgeben */
            lcd_hbyte(CanBotschaft.ID[0]); lcd_putchar(' ');
            lcd_hbyte(CanBotschaft.ID[1]); lcd_putchar(' ');
            lcd_hbyte(CanBotschaft.ID[2]); lcd_putchar(' ');
            lcd_hbyte(CanBotschaft.ID[3]); lcd_putchar(' ');

            /* Wert auch auf D0-D7 ausgeben */
            P5=CanBotschaft.Puffer[0];
        }

    }
    while(1);

}
