/***********************************************/
/*                                             */
/* CAN-Routinen                                */
/*                                             */
/* 18.07.2003                                  */
/* K.-U. Mrkor                                 */
/*                                             */
/***********************************************/

#include <stdio.h>
#include <regc515c.h>
#include <stub.h>

struct CAN_MSG { unsigned char Puffer[8]; unsigned char DatenLaenge; unsigned char ID[4];};

xdata at 0x4100 unsigned char CAN_MODE;
xdata at 0x4101 unsigned char CAN_COMMAND;
xdata at 0x4102 unsigned char CAN_STATUS;

xdata at 0x4104 unsigned char CAN_INTERRUPT_ENABLE;

xdata at 0x4106 unsigned char CAN_BUS_TIMING0;
xdata at 0x4107 unsigned char CAN_BUS_TIMING1;

xdata at 0x4108 unsigned char CAN_OUTPUT_CONTROL;
xdata at 0x4109 unsigned char CAN_TEST;

xdata at 0x4110 unsigned char CAN_ACCEPTANCE_CODE0;
xdata at 0x4111 unsigned char CAN_ACCEPTANCE_CODE1;
xdata at 0x4112 unsigned char CAN_ACCEPTANCE_CODE2;
xdata at 0x4113 unsigned char CAN_ACCEPTANCE_CODE3;
xdata at 0x4114 unsigned char CAN_ACCEPTANCE_MASKE0;
xdata at 0x4115 unsigned char CAN_ACCEPTANCE_MASKE1;
xdata at 0x4116 unsigned char CAN_ACCEPTANCE_MASKE2;
xdata at 0x4117 unsigned char CAN_ACCEPTANCE_MASKE3;

xdata at 0x4110 unsigned char CAN_RECEIVE_FRAMEINFO;
xdata at 0x4111 unsigned char CAN_RECEIVE_ID1;
xdata at 0x4112 unsigned char CAN_RECEIVE_ID2;
xdata at 0x4113 unsigned char CAN_RECEIVE_ID3;
xdata at 0x4114 unsigned char CAN_RECEIVE_ID4;
xdata at 0x4115 unsigned char CAN_RECEIVE_1;
xdata at 0x4116 unsigned char CAN_RECEIVE_2;
xdata at 0x4117 unsigned char CAN_RECEIVE_3;
xdata at 0x4118 unsigned char CAN_RECEIVE_4;
xdata at 0x4119 unsigned char CAN_RECEIVE_5;
xdata at 0x411A unsigned char CAN_RECEIVE_6;
xdata at 0x411B unsigned char CAN_RECEIVE_7;
xdata at 0x411C unsigned char CAN_RECEIVE_8;

xdata at 0x4110 unsigned char CAN_TRANSMIT_FRAMEINFO;
xdata at 0x4111 unsigned char CAN_TRANSMIT_ID1;
xdata at 0x4112 unsigned char CAN_TRANSMIT_ID2;
xdata at 0x4113 unsigned char CAN_TRANSMIT_ID3;
xdata at 0x4114 unsigned char CAN_TRANSMIT_ID4;
xdata at 0x4115 unsigned char CAN_TRANSMIT_1;
xdata at 0x4116 unsigned char CAN_TRANSMIT_2;
xdata at 0x4117 unsigned char CAN_TRANSMIT_3;
xdata at 0x4118 unsigned char CAN_TRANSMIT_4;
xdata at 0x4119 unsigned char CAN_TRANSMIT_5;
xdata at 0x411A unsigned char CAN_TRANSMIT_6;
xdata at 0x411B unsigned char CAN_TRANSMIT_7;
xdata at 0x411C unsigned char CAN_TRANSMIT_8;

xdata at 0x411F unsigned char CAN_CLOCK_DIVIDER;

#define TRUE 1
#define FALSE 0

void CanInit( void);
int CanEmpfang( struct CAN_MSG  xdata *CanBotschaft);
int CanSenden( struct CAN_MSG xdata *CanBotschaft);
