/***********************************************/
/*                                             */
/* CAN-Test   Sender                           */
/*                                             */
/* 18.07.2003                                  */
/* K.-U. Mrkor                                 */
/*                                             */
/***********************************************/

#include <stdio.h>
#include <regc515c.h>
#include <stub.h>

#include "can.h"

struct CAN_MSG  xdata CanBotschaft;               /* sind immerhin 13 Bytes */

/************************************************/
/* MAIN-Routine									*/
/************************************************/
void AksenMain(void)
{

    lcd_puts("CAN-Init");
    CanInit();
    lcd_setxy(1,0);
    lcd_puts("erfolgt");

    do
    {
        /* LCD Ausgabe des aktuellen Wertes */
        lcd_cls();
        lcd_setxy(0,0);
        lcd_puts("wert1=");
        lcd_ubyte(++CanBotschaft.Puffer[0]);

        /* Botschaft aufbereiten und senden */
        CanBotschaft.DatenLaenge=1;
        CanBotschaft.Puffer[0];
        CanBotschaft.ID[0]=0x10;
        CanBotschaft.ID[1]=0x21;
        CanBotschaft.ID[2]=0x32;
        CanBotschaft.ID[3]=0x43;
        CanSenden(&CanBotschaft);

        /* eine kleine Verschaufpause */
        sleep(100);
    }
    while(1);

}
