#include <stdio.h>
#include <stub.h>
#include <regc515c.h>

short int zust = 0;

void smotor_vw()
{
    motor_pwm(0,10);                              // den Strom fr beide Motoren einschalten
    motor_pwm(1,10);                              //

    switch(zust)
    {
        case 3:
            motor_richtung(0,0);
            motor_richtung(1,0);
            break;
        case 0:
            motor_richtung(0,0);
            motor_richtung(1,1);
            break;
        case 1:
            motor_richtung(0,1);
            motor_richtung(1,1);
            break;
        case 2:
            motor_richtung(0,1);
            motor_richtung(1,0);
            break;
    }

    zust++;
    zust %= 4;

    sleep(2);

    motor_pwm(0,0);                               // den Strom fr beide Motoren einschalten
    motor_pwm(1,0);
}


void smotor_rw()
{
    motor_pwm(0,10);                              // den Strom fr beide Motoren einschalten
    motor_pwm(1,10);                              //

    switch(zust)
    {
        case 3:
            motor_richtung(0,1);
            motor_richtung(1,1);
            break;
        case 0:
            motor_richtung(0,1);
            motor_richtung(1,0);
            break;
        case 1:
            motor_richtung(0,0);
            motor_richtung(1,0);
            break;
        case 2:
            motor_richtung(0,0);
            motor_richtung(1,1);
            break;
    }

    zust--;
    zust = (zust+4)%4;

    sleep(2);

    motor_pwm(0,0);                               // den Strom fr beide Motoren einschalten
    motor_pwm(1,0);

}


void smotor(int schritte)
{
    if(schritte > 0)
    {
        for(;schritte > 0;schritte--)
        {
            smotor_vw();
        }
    }
    else if(schritte < 0)
    {
        for(;schritte < 0;schritte++)
        {
            smotor_rw();
        }
    }

}
