/***********************************************/
/*                                             */
/* Ein-/Auschalten des Infrarot-Senders in Ab- */
/* haengigkeit von Digital0 (per Taster)       */
/*                                             */
/* 12.01.2004                                  */
/* K.-U. Mrkor                                 */
/*                                             */
/***********************************************/

#include <stdio.h>
#include <regc515c.h>
#include "stub.h"

/************************************************/
/* MAIN-Routine									*/
/************************************************/
void AksenMain(void)
{

    lcd_puts(" Infrarot-Test  ");
    lcd_setxy(1,0);
    lcd_puts("   - 125 Hz -   ");

    /********************************************************************/
    /* Wert fuer setze_ir_senden() ergibt sich aus halber Periodendauer */
    /* der gewuenschten Frequenz in ms								    */
    /*                                                                  */
    /* mod_ir_senden  | Frequenz                                        */
    /* --------------------------                                       */
    /*   0            | deaktiviert                                     */
    /*   4            |  125 Hz                                         */
    /*   5            |  100 Hz                                         */
    /********************************************************************/

    setze_ir_senden(4);

    do
    {
    }
    while(1);
}
