/***********************************************/
/*                                             */
/* Es werden drei zusaetzliche Prozesse erzeugt*/
/* und alternierend ein Prozess gestoppt und   */
/* gestartet								   */
/*                                             */
/* 23.02.2004                                  */
/* K.-U. Mrkor                                 */
/*                                             */
/***********************************************/

#include <stdio.h>
#include <regc515c.h>
#include <stub.h>

unsigned char j=0;
unsigned char pid_test1=0, pid_test2=0, pid_test3=0;

/*********************************/
/* Blinksignal auf LED 0  */
/*********************************/
void test1( void)
{
    do
    {
        led(0,0);
        sleep(500);
        led(0,1);
        sleep(500);
    }
    while(1);
}


/**************************/
/* Blinksignal auf LED 1  */
/**************************/
void test2( void)
{
    do
    {
        led(1,0);
        sleep(500);
        led(1,1);
        sleep(500);
    }
    while(1);
}


/*********************/
/* Kontroll-Prozess  */
/*********************/
void aufpasser( void)
{
    do
    {
        if (j==128)
        {
            process_kill( pid_test1);
            j++;
        }
        if (j==255)
        {
            pid_test1=process_start( test1, 50);
            j++;
        }
    }
    while(1);
}


/************************************************/
/* MAIN-Routine									*/
/************************************************/
void AksenMain(void)
{

    /* Start von drei Prozessen */
    pid_test1=process_start( test1, 50);
    pid_test2=process_start( test2, 50);
    //pid_test3=process_start( aufpasser, 50);

    do
    {
        lcd_cls();

        /* Einige Statusinformationen ausgeben */
        lcd_puts("liste: ");
        lcd_ubyte(proz_tab.proz_liste[0]);
        lcd_puts(" ");
        lcd_ubyte(proz_tab.proz_liste[1]);
        lcd_puts(" ");
        lcd_ubyte(proz_tab.proz_liste[2]);
        lcd_puts(" ");
        lcd_ubyte(proz_tab.proz_liste[3]);

        lcd_setxy(1,0);
        lcd_puts("ProzAnz:"); lcd_ubyte(proz_tab.anz_proz);
        lcd_puts(" j=");
        lcd_ubyte(j++);

        /* kurz verschnaufen */
        sleep(analog(0));

        if (j==128)
        {
            process_kill( pid_test1);
            j++;
        }

        if (j==255)
        {
            pid_test1=process_start( test1, 50);
            j++;
        }

    }
    while(1);
}
