/***********************************************/
/*                                             */
/* Das gleiche Ansinnen wie beim Bsp. process  */
/* - hier beendet sich der initiale Prozess  - */
/*   AksenMain() selbst 			   		   */
/*											   */
/*                                             */
/* 23.02.2004                                  */
/* K.-U. Mrkor                                 */
/*                                             */
/***********************************************/

#include <stdio.h>
#include <regc515c.h>
#include <stub.h>

unsigned char j=0;
unsigned char pid_test1=25, pid_test2=25, pid_test3=25;

/*********************************/
/* Erzeugt Rechtecksignal auf P5 */
/*********************************/
void test1( void)
{
    do
    {
        P5=~P5;
    }
    while(1);

}


/**************************/
/* Blinksignal auf LED 1  */
/**************************/
void test2( void)
{
    do
    {
        led(1,0);
        sleep(500);
        led(1,1);
        sleep(500);

    }
    while(1);

}


/*********************/
/* Kontroll-Prozess  */
/*********************/
void aufpasser( void)
{

    do
    {
        j++;

        if (j==128)
            pid_test1=process_start( test1, 50);

        if (j==255)
            process_kill( pid_test1);

        lcd_cls();

        lcd_puts("liste: ");
        lcd_ubyte(proz_tab.proz_liste[0]);
        lcd_puts(" ");
        lcd_ubyte(proz_tab.proz_liste[1]);
        lcd_puts(" ");
        lcd_ubyte(proz_tab.proz_liste[2]);
        lcd_puts(" ");
        lcd_ubyte(proz_tab.proz_liste[3]);

        lcd_setxy(1,0);
        lcd_puts("ProzAnz:"); lcd_ubyte(proz_tab.anz_proz);
        lcd_puts(" j=");
        lcd_ubyte(j);

        sleep(40);

    }
    while(1);

}


/************************************************/
/* MAIN-Routine									*/
/************************************************/
void AksenMain(void)
{
    /* Starten der drei Prozesse */
    pid_test2=process_start( test2, 50);
    pid_test3=process_start( aufpasser, 50);

    /* Der Prozess AksenMain() beendet sich selbst (das Leben ist halt grausam) */
    process_kill( process_get_pid());
}
