/***********************************************/
/* Byteweise Ausgabe auf PORT_1 und PORT_2     */
/* PORT_1 wird inkrementiert	               */
/* PORT_2 gibt alternierend 55h/AAh aus        */
/*                                             */
/* 14.12.2004                                  */
/* K.-U. Mrkor                                 */
/***********************************************/

#include <stdio.h>
#include <regc515c.h>
#include <stub.h>

/************************************************/
/* MAIN-Routine									*/
/************************************************/
void AksenMain(void)
{
    unsigned char i=0;

    do
    {
        lcd_home();
        lcd_puts("DigPort1 ++");
        digital_byteout(PORT_1, i++);

        lcd_setxy(1,0);
        lcd_puts("DigPort2 55h/AAh");

        if (i % 2)
            digital_byteout(PORT_2, 0x55);
        else
            digital_byteout(PORT_2, 0xAA);

        sleep(100);
    }
    while(1);
}
