/***********************************************/
/*                                             */
/* Einlesen des DIP-Schalters und Ausgabe der  */
/* Werte (Dez und Binaer) auf dem LCD          */
/*                                             */
/* 11.09.2002                                  */
/* K.-U. Mrkor                                 */
/*                                             */
/***********************************************/

#include <stdio.h>
#include <regc515c.h>
#include "stub.h"

/************************************************/
/* MAIN-Routine									*/
/************************************************/
void AksenMain(void)
{

    do
    {

        lcd_home();
        lcd_puts("DIP (Dez): ");
        lcd_ubyte( dip());

        lcd_setxy(1,0);
        lcd_puts("DIP (Bin): ");

        if (dip_pin(3))
            lcd_putchar('1');
        else
            lcd_putchar('0');

        if (dip_pin(2))
            lcd_putchar('1');
        else
            lcd_putchar('0');

        if (dip_pin(1))
            lcd_putchar('1');
        else
            lcd_putchar('0');

        if (dip_pin(0))
            lcd_putchar('1');
        else
            lcd_putchar('0');

    }
    while(1);
}
