/***********************************************/
/*                                             */
/* Blinker mit 16 Prozessen                    */
/*                                             */
/* 12.05.2004                                  */
/* I. Boersch                                  */
/*                                             */
/***********************************************/

#include <stdio.h>
#include <regc515c.h>
#include <stub.h>

#define WAIT_BEFORE_START 1000
#define HALF_PERIOD 500

void blink(unsigned char id)
{

    while(1)
    {
        // hier eigentlich Semaphore um lcd_setxy und lcd_ubyte notwendig ...
        lcd_setxy(0,id);
        lcd_ubyte(0);
        if (id < 4 ) led(id,0);

        sleep(HALF_PERIOD);

        if (id < 4 ) led(id,1);
        // hier eigentlich Semaphore um lcd_setxy und lcd_ubyte notwendig ...
        lcd_setxy(0,id);
        lcd_ubyte(1);

        sleep(HALF_PERIOD);
    }
}


/*********************************/
/* Blinkprozesse                 */
/*********************************/
void p0( void) {blink(0);}
void p1( void) {blink(1);}
void p2( void) {blink(2);}
void p3( void) {blink(3);}
void p4( void) {blink(4);}
void p5( void) {blink(5);}
void p6( void) {blink(6);}
void p7( void) {blink(7);}
void p8( void) {blink(8);}
void p9( void) {blink(9);}
void p10( void) {blink(10);}
void p11( void) {blink(11);}
void p12( void) {blink(12);}
void p13( void) {blink(13);}
void p14( void) {blink(14);}
void p15( void) {blink(15);}
void p16( void) {blink(16);}

/************************************************/
/* MAIN-Routine									*/
/************************************************/
void AksenMain(void)
{

    /* Starten der Prozesse */
    process_start( p0, 10); sleep(WAIT_BEFORE_START);
    process_start( p1, 10); sleep(WAIT_BEFORE_START);
    process_start( p2, 10); sleep(WAIT_BEFORE_START);
    process_start( p3, 10); sleep(WAIT_BEFORE_START);
    process_start( p4, 10); sleep(WAIT_BEFORE_START);
    process_start( p5, 10); sleep(WAIT_BEFORE_START);
    process_start( p6, 10); sleep(WAIT_BEFORE_START);
    process_start( p7, 10); sleep(WAIT_BEFORE_START);
    process_start( p8, 10); sleep(WAIT_BEFORE_START);
    process_start( p9, 10); sleep(WAIT_BEFORE_START);
    process_start( p10, 10); sleep(WAIT_BEFORE_START);
    process_start( p11, 10); sleep(WAIT_BEFORE_START);
    process_start( p12, 10); sleep(WAIT_BEFORE_START);
    process_start( p13, 10); sleep(WAIT_BEFORE_START);
    process_start( p14, 10); sleep(WAIT_BEFORE_START);
    process_start( p15, 10); sleep(WAIT_BEFORE_START);
    process_start( p16, 10); sleep(WAIT_BEFORE_START);

    /* harakiri */
    process_kill( process_get_pid());
}
