;--------------------------------------------------------
; File Created by SDCC : FreeWare ANSI-C Compiler
; Version 2.4.0 Wed Apr 28 11:11:15 2004

;--------------------------------------------------------
	.module rtc390
	.optsdcc -mds390 --model-flat24
	
.flat24 on		; 24 bit flat addressing
dpx = 0x93		; dpx register unknown to assembler
dps = 0x86		; dps register unknown to assembler
dpl1 = 0x84		; dpl1 register unknown to assembler
dph1 = 0x85		; dph1 register unknown to assembler
dpx1 = 0x95		; dpx1 register unknown to assembler
ap = 0x9C		; ap register unknown to assembler
_ap = 0x9C		; _ap register unknown to assembler
mcnt0 = 0xD1		; mcnt0 register unknown to assembler
mcnt1 = 0xD2		; mcnt1 register unknown to assembler
ma = 0xD3		; ma register unknown to assembler
mb = 0xD4		; mb register unknown to assembler
mc = 0xD5		; mc register unknown to assembler
F1 = 0xD1		; F1 user flag unknown to assembler
esp = 0x9B		; ESP user flag unknown to assembler
;--------------------------------------------------------
; Public variables in this module
;--------------------------------------------------------
	.globl _rtcMagic
	.globl _RtcRead
	.globl _RtcWrite
;--------------------------------------------------------
; special function registers
;--------------------------------------------------------
_P4	=	0x0080
_SP	=	0x0081
_DPL	=	0x0082
_DPH	=	0x0083
_DPL1	=	0x0084
_DPH1	=	0x0085
_DPS	=	0x0086
_PCON	=	0x0087
_TCON	=	0x0088
_TMOD	=	0x0089
_TL0	=	0x008a
_TL1	=	0x008b
_TH0	=	0x008c
_TH1	=	0x008d
_CKCON	=	0x008e
_P1	=	0x0090
_EXIF	=	0x0091
_P4CNT	=	0x0092
_DPX	=	0x0093
_DPX1	=	0x0095
_SCON0	=	0x0098
_SBUF0	=	0x0099
_ESP	=	0x009b
_AP	=	0x009c
_ACON	=	0x009d
_P2	=	0x00a0
_P5	=	0x00a1
_P5CNT	=	0x00a2
_IE	=	0x00a8
_P3	=	0x00b0
_IP	=	0x00b8
_SCON1	=	0x00c0
_SBUF1	=	0x00c1
_PMR	=	0x00c4
_MCON	=	0x00c6
_TA	=	0x00c7
_T2CON	=	0x00c8
_T2MOD	=	0x00c9
_RCAP2L	=	0x00ca
_RTL2	=	0x00ca
_RCAP2H	=	0x00cb
_RTH2	=	0x00cb
_TL2	=	0x00cc
_TH2	=	0x00cd
_PSW	=	0x00d0
_MCNT0	=	0x00d1
_MCNT1	=	0x00d2
_MA	=	0x00d3
_MB	=	0x00d4
_MC	=	0x00d5
_WDCON	=	0x00d8
_ACC	=	0x00e0
_EIE	=	0x00e8
_MXAX	=	0x00ea
_B	=	0x00f0
_EIP	=	0x00f8
;--------------------------------------------------------
; special function bits 
;--------------------------------------------------------
_IT0	=	0x0088
_IE0	=	0x0089
_IT1	=	0x008a
_IE1	=	0x008b
_TR0	=	0x008c
_TF0	=	0x008d
_TR1	=	0x008e
_TF1	=	0x008f
_T2	=	0x0090
_T2EX	=	0x0091
_RXD1	=	0x0092
_TXD1	=	0x0093
_INT2	=	0x0094
_INT3	=	0x0095
_INT4	=	0x0096
_INT5	=	0x0097
_RI_0	=	0x0098
_TI_0	=	0x0099
_RB8_0	=	0x009a
_TB8_0	=	0x009b
_REN_0	=	0x009c
_SM2_0	=	0x009d
_SM1_0	=	0x009e
_SM0_0	=	0x009f
_FE_0	=	0x009f
_EX0	=	0x00a8
_ET0	=	0x00a9
_EX1	=	0x00aa
_ET1	=	0x00ab
_ES0	=	0x00ac
_ET2	=	0x00ad
_ES1	=	0x00ae
_EA	=	0x00af
_RXD0	=	0x00b0
_TXD0	=	0x00b1
_INT0	=	0x00b2
_INT1	=	0x00b3
_T0	=	0x00b4
_T1	=	0x00b5
_WR	=	0x00b6
_RD	=	0x00b7
_PX0	=	0x00b8
_PT0	=	0x00b9
_PX1	=	0x00ba
_PT1	=	0x00bb
_PS0	=	0x00bc
_PT2	=	0x00bd
_PS1	=	0x00be
_RI_1	=	0x00c0
_TI_1	=	0x00c1
_RB8_1	=	0x00c2
_TB8_1	=	0x00c3
_REN_1	=	0x00c4
_SM2_1	=	0x00c5
_SM1_1	=	0x00c6
_SM0_1	=	0x00c7
_FE_1	=	0x00c7
_CP_RL	=	0x00c8
_C_T	=	0x00c9
_TR2	=	0x00ca
_EXEN2	=	0x00cb
_TCLK	=	0x00cc
_RCLK	=	0x00cd
_EXF2	=	0x00ce
_TF2	=	0x00cf
_P	=	0x00d0
_F1	=	0x00d1
_OV	=	0x00d2
_RS0	=	0x00d3
_RS1	=	0x00d4
_F0	=	0x00d5
_AC	=	0x00d6
_CY	=	0x00d7
_RWT	=	0x00d8
_EWT	=	0x00d9
_WDRF	=	0x00da
_WDIF	=	0x00db
_PFI	=	0x00dc
_EPFI	=	0x00dd
_POR	=	0x00de
_SMOD_1	=	0x00df
_EX2	=	0x00e8
_EX3	=	0x00e9
_EX4	=	0x00ea
_EX5	=	0x00eb
_EWDI	=	0x00ec
_C1IE	=	0x00ed
_C0IE	=	0x00ee
_CANBIE	=	0x00ef
_PX2	=	0x00f8
_PX3	=	0x00f9
_PX4	=	0x00fa
_PX5	=	0x00fb
_PWDI	=	0x00fc
_C1IP	=	0x00fd
_C0IP	=	0x00fe
_CANBIP	=	0x00ff
;--------------------------------------------------------
; overlayable register banks 
;--------------------------------------------------------
	.area REG_BANK_0	(REL,OVR,DATA)
	.ds 8
;--------------------------------------------------------
; internal ram data
;--------------------------------------------------------
	.area DSEG    (DATA)
;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
	.area OSEG    (OVR,DATA)
;--------------------------------------------------------
; indirectly addressable internal ram data
;--------------------------------------------------------
	.area ISEG    (DATA)
;--------------------------------------------------------
; bit data
;--------------------------------------------------------
	.area BSEG    (BIT)
;--------------------------------------------------------
; external ram data
;--------------------------------------------------------
	.area XSEG    (XDATA)
_rtc	=	0x310000
_RtcRead_rtcDate_1_1::
	.ds 4
_RtcRead_rtcBytes_1_1::
	.ds 8
_RtcWrite_rtcBytes_1_1::
	.ds 8
;--------------------------------------------------------
; external initialized ram data
;--------------------------------------------------------
	.area XISEG   (XDATA)
;--------------------------------------------------------
; global & static initialisations
;--------------------------------------------------------
	.area GSINIT  (CODE)
	.area GSFINAL (CODE)
	.area GSINIT  (CODE)
;--------------------------------------------------------
; Home
;--------------------------------------------------------
	.area HOME    (CODE)
	.area CSEG    (CODE)
;--------------------------------------------------------
; code
;--------------------------------------------------------
	.area CSEG    (CODE)
;------------------------------------------------------------
;Allocation info for local variables in function 'RtcSync'
;------------------------------------------------------------
;dummy                     Allocated to registers 
;byte                      Allocated to registers 
;bitMask                   Allocated to registers r3 
;------------------------------------------------------------
;	rtc390.c:43: static void RtcSync(void) {
;	genFunction 
;	-----------------------------------------
;	 function RtcSync
;	-----------------------------------------
_RtcSync:
	ar2 = 0x02
	ar3 = 0x03
	ar4 = 0x04
	ar5 = 0x05
	ar6 = 0x06
	ar7 = 0x07
	ar0 = 0x00
	ar1 = 0x01
;	rtc390.c:47: dummy=rtc;
;     genDummyRead
	mov	dptr,#_rtc
	movx	a,@dptr
;	rtc390.c:50: for (byte=0; byte<8; byte++) {
;	genAssign 
;	genAssign: resultIsFar = FALSE
	mov	r2,#0x00
;	genLabel 
00105$:
;	genCmpLt 
;	genCmp
	cjne	r2,#0x08,00118$
00118$:
;	genIfxJump
; Peephole 108   removed ljmp by inverse jump logic
	jnc  00109$
00119$:
;	rtc390.c:51: for (bitMask=0x01; bitMask; bitMask<<=1) {
;	genAssign 
;	genAssign: resultIsFar = TRUE
	mov	r3,#0x01
;	genPlus 
	mov	a,r2
; Peephole 3.d   changed mov to clr
; Peephole 3.d   changed mov to clr
;	genPointerGet 
; Peephole 227.a movc optimize
	mov	dptr,#_rtcMagic
	movc	a,@a+dptr
	mov	r4,a
;	genLabel 
00101$:
;	genIfx 
	mov	a,r3
;	genIfxJump
; Peephole 110   removed ljmp by inverse jump logic
	jz  00107$
00120$:
;	rtc390.c:52: rtc = (rtcMagic[byte]&bitMask) ? 0xff : 0x00;
;	genAnd 
	mov	a,r4
	anl	a,r3
;	genIfx 
;	genIfxJump
; Peephole 110   removed ljmp by inverse jump logic
	jz  00111$
00121$:
;	genAssign 
;	genAssign: resultIsFar = FALSE
	mov	r5,#0xFF
;	genGoto 
;	genLabel 
; Peephole 132   changed ljmp to sjmp
	sjmp 00112$
00111$:
;	genAssign 
;	genAssign: resultIsFar = FALSE
	mov	r5,#0x00
;	genLabel 
00112$:
;	genAssign 
;	genAssign: resultIsFar = TRUE
	mov	dptr,#_rtc
	mov	a,r5
	movx	@dptr,a
;	rtc390.c:51: for (bitMask=0x01; bitMask; bitMask<<=1) {
;	genLeftShift 
;	genLeftShiftLiteral (1), size 1
;	genlshOne 
	mov	a,r3
	add	a,acc
	mov	r5,a
;	genAssign 
;	genAssign: resultIsFar = TRUE
	mov	ar3,r5
;	genGoto 
;	genLabel 
; Peephole 132   changed ljmp to sjmp
	sjmp 00101$
00107$:
;	rtc390.c:50: for (byte=0; byte<8; byte++) {
;	genPlus 
	inc	r2
;	did genPlusIncr
;	genGoto 
;	genLabel 
; Peephole 132   changed ljmp to sjmp
	sjmp 00105$
00109$:
;	genEndFunction 
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'RtcRead'
;------------------------------------------------------------
;rtcDate                   Allocated with name '_RtcRead_rtcDate_1_1'
;rtcBytes                  Allocated with name '_RtcRead_rtcBytes_1_1'
;byte                      Allocated to registers 
;bitMask                   Allocated to registers r2 
;------------------------------------------------------------
;	rtc390.c:57: unsigned char RtcRead(struct tm *rtcDate) {
;	genFunction 
;	-----------------------------------------
;	 function RtcRead
;	-----------------------------------------
_RtcRead:
;	genReceive 
	mov     dps, #1
	mov     dptr, #_RtcRead_rtcDate_1_1
	mov	a,dpl
	movx	@dptr,a
	inc	dptr
	mov	a,dph
	movx	@dptr,a
	inc	dptr
	mov	a,dpx
	movx	@dptr,a
	inc	dptr
	mov	a,b
	movx	@dptr,a
	mov	dps,#0
;	rtc390.c:61: RtcSync();
;	genCall 
	lcall	_RtcSync
;	rtc390.c:63: for (byte=0; byte<8; byte++) {
;	genAssign 
;	genAssign: resultIsFar = FALSE
	mov	r6,#0x00
;	genLabel 
00110$:
;	genCmpLt 
;	genCmp
	cjne	r6,#0x08,00122$
00122$:
;	genIfxJump
; Peephole 108   removed ljmp by inverse jump logic
	jnc  00113$
00123$:
;	rtc390.c:64: rtcBytes[byte]=0;
;	genPlus 
	mov	a,r6
	add	a,#_RtcRead_rtcBytes_1_1
	mov	dpl,a
; Peephole 3.d   changed mov to clr
	clr	a
	addc	a,#(_RtcRead_rtcBytes_1_1 >> 8)
	mov	dph,a
; Peephole 3.d   changed mov to clr
	clr	a
	addc	a,#(_RtcRead_rtcBytes_1_1 >> 16)
	mov	dpx,a
;	genPointerSet 
; Peephole 180   changed mov to clr
	clr  a
	movx	@dptr,a
;	rtc390.c:65: for (bitMask=0x01; bitMask; bitMask<<=1) {
;	genAssign 
;	genAssign: resultIsFar = TRUE
	mov	r2,#0x01
;	genAssign 
;	genAssign: resultIsFar = FALSE
	mov	dpl1,dpl
	mov	dph1,dph
	mov	dpx1,dpx
;	genLabel 
00106$:
;	genIfx 
	mov	a,r2
;	genIfxJump
; Peephole 110   removed ljmp by inverse jump logic
	jz  00112$
00124$:
;	rtc390.c:66: if (rtc&1) {
;	genAnd 
	mov	dptr,#_rtc
	movx	a,@dptr
;	genIfxJump
; Peephole 111   removed ljmp by inverse jump logic
	jnb  acc.0,00108$
00125$:
;	rtc390.c:67: rtcBytes[byte]|=bitMask;
;	genPointerGet 
;	genFarPointerGet
	inc	dps
	movx	a,@dptr
	mov	r7,a
	mov	dps,#0
;	genOr 
	mov	a,r2
	orl	ar7,a
;	genPointerSet 
	mov	a,r7
	inc	dps
	movx	@dptr,a
	mov	dps,#0
;	genLabel 
00108$:
;	rtc390.c:65: for (bitMask=0x01; bitMask; bitMask<<=1) {
;	genLeftShift 
;	genLeftShiftLiteral (1), size 1
;	genlshOne 
	mov	a,r2
	add	a,acc
	mov	r7,a
;	genAssign 
;	genAssign: resultIsFar = TRUE
	mov	ar2,r7
;	genGoto 
;	genLabel 
; Peephole 132   changed ljmp to sjmp
	sjmp 00106$
00112$:
;	rtc390.c:63: for (byte=0; byte<8; byte++) {
;	genPlus 
	inc	r6
;	did genPlusIncr
;	genGoto 
;	genLabel 
; Peephole 132   changed ljmp to sjmp
	sjmp 00110$
00113$:
;	rtc390.c:71: rtcDate->tm_year=BCDtoINT(rtcBytes[7])+100; // year since 1900
;	genPlus 
	mov	dptr,#_RtcRead_rtcDate_1_1
;	Swapped plus args.
	movx	a,@dptr
	add	a,#0x05
	mov	r2,a
	inc	dptr
	movx	a,@dptr
	addc	a,#0x00
	mov	r3,a
	inc	dptr
	movx	a,@dptr
	addc	a,#0x00
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
;	genPointerGet 
;	genFarPointerGet
	mov	dptr,#(_RtcRead_rtcBytes_1_1 + 0x0007)
	movx	a,@dptr
;	genAnd 
;	better literal AND.
; Peephole 105   removed redundant mov
	mov  r6,a
	anl	a, #0x0F
	mov	r7,a
;	genCast 
	mov	r0,#0
;	genRightShift 
;	genRightShiftLiteral (4), size 1
;	genrshOne
	mov	a,r6
	swap	a
	anl	a,#0x0F
	mov	r6,a
;	genMult 
	mov	b,#0x0A
	mov	a,r6
	mul	ab
;	genPlus 
; Peephole 229.b redundant move
	mov	r6,a
	mov	r1,b
	add	a,r7
	mov	r7,a
	mov	a,r1
	addc	a,r0
	mov	r0,a
;	genPlus 
	mov	a,#0x64
	add	a,r7
	mov	r7,a
; Peephole 180   changed mov to clr
	clr  a
	addc	a,r0
	mov	r0,a
;	genPointerSet 
	mov	dpl,r2
	mov	dph,r3
	mov	dpx,r4
	mov	b,r5
	mov	_ap, r7
	mov	a,r0
	lcall	__gptrputWord
;	rtc390.c:72: rtcDate->tm_mon=BCDtoINT(rtcBytes[6])-1; // jan=0
;	genPlus 
	mov	dptr,#_RtcRead_rtcDate_1_1
;	Swapped plus args.
	movx	a,@dptr
	add	a,#0x04
	mov	r2,a
	inc	dptr
	movx	a,@dptr
	addc	a,#0x00
	mov	r3,a
	inc	dptr
	movx	a,@dptr
	addc	a,#0x00
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
;	genPointerGet 
;	genFarPointerGet
	mov	dptr,#(_RtcRead_rtcBytes_1_1 + 0x0006)
	movx	a,@dptr
;	genAnd 
;	better literal AND.
; Peephole 105   removed redundant mov
	mov  r6,a
	anl	a, #0x0F
	mov	r7,a
;	genRightShift 
;	genRightShiftLiteral (4), size 1
;	genrshOne
	mov	a,r6
	swap	a
	anl	a,#0x0F
	mov	r6,a
;	genMult 
	mov	b,#0x0A
	mov	a,r6
	mul	ab
;	genPlus 
; Peephole 105   removed redundant mov
	mov  r6,a
	add	a,r7
	mov	r7,a
;	genMinus 
	dec	r7
;	genPointerSet 
	mov	dpl,r2
	mov	dph,r3
	mov	dpx,r4
	mov	b,r5
	mov	a,r7
	lcall	__gptrput
;	rtc390.c:73: rtcDate->tm_mday=BCDtoINT(rtcBytes[5]);
;	genPlus 
	mov	dptr,#_RtcRead_rtcDate_1_1
;	Swapped plus args.
	movx	a,@dptr
	add	a,#0x03
	mov	r2,a
	inc	dptr
	movx	a,@dptr
	addc	a,#0x00
	mov	r3,a
	inc	dptr
	movx	a,@dptr
	addc	a,#0x00
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
;	genPointerGet 
;	genFarPointerGet
	mov	dptr,#(_RtcRead_rtcBytes_1_1 + 0x0005)
	movx	a,@dptr
;	genAnd 
;	better literal AND.
; Peephole 105   removed redundant mov
	mov  r6,a
	anl	a, #0x0F
	mov	r7,a
;	genRightShift 
;	genRightShiftLiteral (4), size 1
;	genrshOne
	mov	a,r6
	swap	a
	anl	a,#0x0F
	mov	r6,a
;	genMult 
	mov	b,#0x0A
	mov	a,r6
	mul	ab
;	genPlus 
; Peephole 105   removed redundant mov
	mov  r6,a
	add	a,r7
	mov	r7,a
;	genPointerSet 
	mov	dpl,r2
	mov	dph,r3
	mov	dpx,r4
	mov	b,r5
	mov	a,r7
	lcall	__gptrput
;	rtc390.c:74: rtcDate->tm_wday=(rtcBytes[4]&0x07)-1; // monday=0?
;	genPlus 
	mov	dptr,#_RtcRead_rtcDate_1_1
;	Swapped plus args.
	movx	a,@dptr
	add	a,#0x07
	mov	r2,a
	inc	dptr
	movx	a,@dptr
	addc	a,#0x00
	mov	r3,a
	inc	dptr
	movx	a,@dptr
	addc	a,#0x00
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
;	genPointerGet 
;	genFarPointerGet
	mov	dptr,#(_RtcRead_rtcBytes_1_1 + 0x0004)
	movx	a,@dptr
;	genAnd 
;	better literal AND.
; Peephole 105   removed redundant mov
	mov  r6,a
	anl	a, #0x07
	mov	r7,a
;	genMinus 
	dec	r7
;	genPointerSet 
	mov	dpl,r2
	mov	dph,r3
	mov	dpx,r4
	mov	b,r5
	mov	a,r7
	lcall	__gptrput
;	rtc390.c:75: rtcDate->tm_hour=BCDtoINT(rtcBytes[3]);
;	genPlus 
	mov	dptr,#_RtcRead_rtcDate_1_1
;	Swapped plus args.
	movx	a,@dptr
	add	a,#0x02
	mov	r2,a
	inc	dptr
	movx	a,@dptr
	addc	a,#0x00
	mov	r3,a
	inc	dptr
	movx	a,@dptr
	addc	a,#0x00
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
;	genPointerGet 
;	genFarPointerGet
	mov	dptr,#(_RtcRead_rtcBytes_1_1 + 0x0003)
	movx	a,@dptr
;	genAnd 
;	better literal AND.
; Peephole 105   removed redundant mov
	mov  r7,a
	anl	a, #0x0F
	mov	r0,a
;	genRightShift 
;	genRightShiftLiteral (4), size 1
;	genrshOne
	mov	a,r7
	swap	a
	anl	a,#0x0F
	mov	r1,a
;	genMult 
	mov	b,#0x0A
	mov	a,r1
	mul	ab
;	genPlus 
; Peephole 105   removed redundant mov
	mov  r1,a
	add	a,r0
	mov	r0,a
;	genPointerSet 
	mov	dpl,r2
	mov	dph,r3
	mov	dpx,r4
	mov	b,r5
	mov	a,r0
	lcall	__gptrput
;	rtc390.c:76: rtcDate->tm_min=BCDtoINT(rtcBytes[2]);
;	genPlus 
	mov	dptr,#_RtcRead_rtcDate_1_1
;	Swapped plus args.
	movx	a,@dptr
	add	a,#0x01
	mov	r2,a
	inc	dptr
	movx	a,@dptr
	addc	a,#0x00
	mov	r3,a
	inc	dptr
	movx	a,@dptr
	addc	a,#0x00
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
;	genPointerGet 
;	genFarPointerGet
	mov	dptr,#(_RtcRead_rtcBytes_1_1 + 0x0002)
	movx	a,@dptr
;	genAnd 
;	better literal AND.
; Peephole 105   removed redundant mov
	mov  r0,a
	anl	a, #0x0F
	mov	r1,a
;	genRightShift 
;	genRightShiftLiteral (4), size 1
;	genrshOne
	mov	a,r0
	swap	a
	anl	a,#0x0F
	mov	r0,a
;	genMult 
	mov	b,#0x0A
	mov	a,r0
	mul	ab
;	genPlus 
; Peephole 105   removed redundant mov
	mov  r0,a
	add	a,r1
	mov	r1,a
;	genPointerSet 
	mov	dpl,r2
	mov	dph,r3
	mov	dpx,r4
	mov	b,r5
	mov	a,r1
	lcall	__gptrput
;	rtc390.c:77: rtcDate->tm_sec=BCDtoINT(rtcBytes[1]);
;	genPointerGet 
;	genFarPointerGet
	mov	dptr,#(_RtcRead_rtcBytes_1_1 + 0x0001)
	movx	a,@dptr
;	genAnd 
;	better literal AND.
; Peephole 105   removed redundant mov
	mov  r2,a
	anl	a, #0x0F
	mov	r3,a
;	genRightShift 
;	genRightShiftLiteral (4), size 1
;	genrshOne
	mov	a,r2
	swap	a
	anl	a,#0x0F
	mov	r2,a
;	genMult 
	mov	b,#0x0A
	mov	a,r2
	mul	ab
;	genPlus 
; Peephole 105   removed redundant mov
	mov  r2,a
	add	a,r3
	mov	r3,a
;	genPointerSet 
	mov     dps, #1
	mov     dptr, #_RtcRead_rtcDate_1_1
	movx	a,@dptr
	mov	dpl,a
	inc	dptr
	movx	a,@dptr
	mov	dph,a
	inc	dptr
	movx	a,@dptr
	mov	dpx,a
	inc	dptr
	movx	a,@dptr
	mov	b,a
	mov	dps,#0
	mov	a,r3
	lcall	__gptrput
;	rtc390.c:78: rtcDate->tm_hundredth=BCDtoINT(rtcBytes[0]);
;	genPlus 
	mov	dptr,#_RtcRead_rtcDate_1_1
;	Swapped plus args.
	movx	a,@dptr
	add	a,#0x0B
	mov	r2,a
	inc	dptr
	movx	a,@dptr
	addc	a,#0x00
	mov	r3,a
	inc	dptr
	movx	a,@dptr
	addc	a,#0x00
	mov	r4,a
	inc	dptr
	movx	a,@dptr
	mov	r5,a
;	genPointerGet 
;	genFarPointerGet
	mov	dptr,#_RtcRead_rtcBytes_1_1
	movx	a,@dptr
;	genAnd 
;	better literal AND.
; Peephole 105   removed redundant mov
	mov  r0,a
	anl	a, #0x0F
	mov	r1,a
;	genRightShift 
;	genRightShiftLiteral (4), size 1
;	genrshOne
	mov	a,r0
	swap	a
	anl	a,#0x0F
	mov	r0,a
;	genMult 
	mov	b,#0x0A
	mov	a,r0
	mul	ab
;	genPlus 
; Peephole 105   removed redundant mov
	mov  r0,a
	add	a,r1
	mov	r1,a
;	genPointerSet 
	mov	dpl,r2
	mov	dph,r3
	mov	dpx,r4
	mov	b,r5
	mov	a,r1
	lcall	__gptrput
;	rtc390.c:79: if ((rtcBytes[4]&0x30) || (rtcBytes[3]&0x80)) {
;	genAnd 
	mov	a,r6
	anl	a,#0x30
; Peephole 162   removed sjmp by inverse jump logic
	jz   00127$
00126$:
; Peephole 132   changed ljmp to sjmp
	sjmp 00103$
00127$:
;	genAnd 
	mov	a,r7
;	genIfxJump
; Peephole 111   removed ljmp by inverse jump logic
	jnb  acc.7,00104$
00128$:
;	genLabel 
00103$:
;	rtc390.c:81: return 0;
;	genRet 
	mov	dpl,#0x00
;	genLabel 
; Peephole 132   changed ljmp to sjmp
;	rtc390.c:83: return 1;
;	genRet 
;	genLabel 
;	genEndFunction 
; Peephole 237a  removed sjmp to ret
	ret
00104$:
	mov     dpl,#0x01
00114$:
	ret
;------------------------------------------------------------
;Allocation info for local variables in function 'RtcWrite'
;------------------------------------------------------------
;rtcDate                   Allocated to registers r2 r3 r4 r5 
;rtcBytes                  Allocated with name '_RtcWrite_rtcBytes_1_1'
;byte                      Allocated to registers 
;bitMask                   Allocated to registers r3 
;------------------------------------------------------------
;	rtc390.c:86: void RtcWrite(struct tm *rtcDate) {
;	genFunction 
;	-----------------------------------------
;	 function RtcWrite
;	-----------------------------------------
_RtcWrite:
;	genReceive 
	mov	r2,dpl
	mov	r3,dph
	mov	r4,dpx
	mov	r5,b
;	rtc390.c:90: rtcBytes[7]=INTtoBCD(rtcDate->tm_year%100);
;	genPlus 
	mov	a,#0x05
	add	a,r2
	mov	r6,a
; Peephole 180   changed mov to clr
	clr  a
	addc	a,r3
	mov	r7,a
; Peephole 180   changed mov to clr
	clr  a
	addc	a,r4
	mov	r0,a
	mov	ar1,r5
;	genPointerGet 
;	genGenPointerGet 
	mov	dpl,r6
	mov	dph,r7
	mov	dpx,r0
	mov	b,r1
	lcall	__gptrgetWord
	mov	r6,_ap
	mov	r7,a
;	genAssign 
;	genAssign: resultIsFar = TRUE
	mov	dptr,#__modsint_PARM_2
	mov	a,#0x64
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
;	genCall 
	push	ar2
	push	ar3
	push	ar4
	push	ar5
;	genSend argreg = 1, size = 2 
	mov	dpl,r6
	mov	dph,r7
	lcall	__modsint
	mov	r6,dpl
	mov	r7,dph
	pop	ar5
	pop	ar4
	pop	ar3
	pop	ar2
;	genAssign 
;	genAssign: resultIsFar = TRUE
	mov	dptr,#__modsint_PARM_2
	mov	a,#0x0A
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
;	genCall 
	push	ar2
	push	ar3
	push	ar4
	push	ar5
	push	ar6
	push	ar7
;	genSend argreg = 1, size = 2 
	mov	dpl,r6
	mov	dph,r7
	lcall	__modsint
	pop	ar7
	pop	ar6
	pop	ar5
	pop	ar4
	pop	ar3
	pop	ar2
;	genCast 
	mov	r0,dpl
;	genAssign 
;	genAssign: resultIsFar = TRUE
	mov	dptr,#__divsint_PARM_2
	mov	a,#0x0A
	movx	@dptr,a
	clr	a
	inc	dptr
	movx	@dptr,a
;	genCall 
	push	ar2
	push	ar3
	push	ar4
	push	ar5
	push	ar0
;	genSend argreg = 1, size = 2 
	mov	dpl,r6
	mov	dph,r7
	lcall	__divsint
	pop	ar0
	pop	ar5
	pop	ar4
	pop	ar3
	pop	ar2
;	genCast 
	mov	r6,dpl
;	genLeftShift 
;	genLeftShiftLiteral (4), size 1
;	genlshOne 
	mov	a,r6
	swap	a
	anl	a,#0xF0
;	genPlus 
; Peephole 105   removed redundant mov
	mov  r6,a
	add	a,r0
;	genPointerSet 
; Peephole 100   removed redundant mov
	mov  r0,a
	mov  dptr,#(_RtcWrite_rtcBytes_1_1 + 0x0007)
	movx @dptr,a
;	rtc390.c:91: rtcBytes[6]=INTtoBCD(rtcDate->tm_mon)+1;
;	genPlus 
	mov	a,#0x04
	add	a,r2
	mov	r6,a
; Peephole 180   changed mov to clr
	clr  a
	addc	a,r3
	mov	r7,a
; Peephole 180   changed mov to clr
	clr  a
	addc	a,r4
	mov	r0,a
	mov	ar1,r5
;	genPointerGet 
;	genGenPointerGet 
	mov	dpl,r6
	mov	dph,r7
	mov	dpx,r0
	mov	b,r1
	lcall	__gptrget
;	genMod 
;	DS80C390 div bug: rearranged ops.
; Peephole 105   removed redundant mov
	mov  r6,a
	mov	b,#0x0A
	div	ab
	mov	r7,b
;	genDiv 
;	DS80C390 div bug: rearranged ops.
	mov	a,r6
	mov	b,#0x0A
	div	ab
;	genLeftShift 
;	genLeftShiftLiteral (4), size 1
;	genlshOne 
; Peephole 105   removed redundant mov
	mov  r6,a
	swap	a
	anl	a,#0xF0
;	genPlus 
; Peephole 105   removed redundant mov
	mov  r6,a
	add	a,r7
;	genPlus 
; Peephole 185   changed order of increment (acc incremented also!)
	inc  a
;	did genPlusIncr
;	genPointerSet 
; Peephole 100   removed redundant mov
	mov  r7,a
	mov  dptr,#(_RtcWrite_rtcBytes_1_1 + 0x0006)
	movx @dptr,a
;	rtc390.c:92: rtcBytes[5]=INTtoBCD(rtcDate->tm_mday);
;	genPlus 
	mov	a,#0x03
	add	a,r2
	mov	r6,a
; Peephole 180   changed mov to clr
	clr  a
	addc	a,r3
	mov	r7,a
; Peephole 180   changed mov to clr
	clr  a
	addc	a,r4
	mov	r0,a
	mov	ar1,r5
;	genPointerGet 
;	genGenPointerGet 
	mov	dpl,r6
	mov	dph,r7
	mov	dpx,r0
	mov	b,r1
	lcall	__gptrget
;	genMod 
;	DS80C390 div bug: rearranged ops.
; Peephole 105   removed redundant mov
	mov  r6,a
	mov	b,#0x0A
	div	ab
	mov	r7,b
;	genDiv 
;	DS80C390 div bug: rearranged ops.
	mov	a,r6
	mov	b,#0x0A
	div	ab
;	genLeftShift 
;	genLeftShiftLiteral (4), size 1
;	genlshOne 
; Peephole 105   removed redundant mov
	mov  r6,a
	swap	a
	anl	a,#0xF0
;	genPlus 
; Peephole 105   removed redundant mov
	mov  r6,a
	add	a,r7
;	genPointerSet 
; Peephole 100   removed redundant mov
	mov  r7,a
	mov  dptr,#(_RtcWrite_rtcBytes_1_1 + 0x0005)
	movx @dptr,a
;	rtc390.c:93: rtcBytes[4]=(INTtoBCD(rtcDate->tm_wday)+1)&0x07; //set 24h  mode
;	genPlus 
	mov	a,#0x07
	add	a,r2
	mov	r6,a
; Peephole 180   changed mov to clr
	clr  a
	addc	a,r3
	mov	r7,a
; Peephole 180   changed mov to clr
	clr  a
	addc	a,r4
	mov	r0,a
	mov	ar1,r5
;	genPointerGet 
;	genGenPointerGet 
	mov	dpl,r6
	mov	dph,r7
	mov	dpx,r0
	mov	b,r1
	lcall	__gptrget
;	genMod 
;	DS80C390 div bug: rearranged ops.
; Peephole 105   removed redundant mov
	mov  r6,a
	mov	b,#0x0A
	div	ab
	mov	r7,b
;	genDiv 
;	DS80C390 div bug: rearranged ops.
	mov	a,r6
	mov	b,#0x0A
	div	ab
;	genLeftShift 
;	genLeftShiftLiteral (4), size 1
;	genlshOne 
; Peephole 105   removed redundant mov
	mov  r6,a
	swap	a
	anl	a,#0xF0
;	genPlus 
; Peephole 105   removed redundant mov
	mov  r6,a
	add	a,r7
;	genPlus 
; Peephole 185   changed order of increment (acc incremented also!)
	inc  a
	mov  r7,a
;	did genPlusIncr
;	genAnd 
	anl	ar7,#0x07
;	genPointerSet 
	mov	dptr,#(_RtcWrite_rtcBytes_1_1 + 0x0004)
	mov	a,r7
	movx	@dptr,a
;	rtc390.c:94: rtcBytes[3]=INTtoBCD(rtcDate->tm_hour)&0x3f; // oscilator on, reset on
;	genPlus 
	mov	a,#0x02
	add	a,r2
	mov	r6,a
; Peephole 180   changed mov to clr
	clr  a
	addc	a,r3
	mov	r7,a
; Peephole 180   changed mov to clr
	clr  a
	addc	a,r4
	mov	r0,a
	mov	ar1,r5
;	genPointerGet 
;	genGenPointerGet 
	mov	dpl,r6
	mov	dph,r7
	mov	dpx,r0
	mov	b,r1
	lcall	__gptrget
;	genMod 
;	DS80C390 div bug: rearranged ops.
; Peephole 105   removed redundant mov
	mov  r6,a
	mov	b,#0x0A
	div	ab
	mov	r7,b
;	genDiv 
;	DS80C390 div bug: rearranged ops.
	mov	a,r6
	mov	b,#0x0A
	div	ab
;	genLeftShift 
;	genLeftShiftLiteral (4), size 1
;	genlshOne 
; Peephole 105   removed redundant mov
	mov  r6,a
	swap	a
	anl	a,#0xF0
;	genPlus 
; Peephole 105   removed redundant mov
	mov  r6,a
	add	a,r7
	mov	r7,a
;	genAnd 
	anl	ar7,#0x3F
;	genPointerSet 
	mov	dptr,#(_RtcWrite_rtcBytes_1_1 + 0x0003)
	mov	a,r7
	movx	@dptr,a
;	rtc390.c:95: rtcBytes[2]=INTtoBCD(rtcDate->tm_min);
;	genPlus 
	mov	a,#0x01
	add	a,r2
	mov	r6,a
; Peephole 180   changed mov to clr
	clr  a
	addc	a,r3
	mov	r7,a
; Peephole 180   changed mov to clr
	clr  a
	addc	a,r4
	mov	r0,a
	mov	ar1,r5
;	genPointerGet 
;	genGenPointerGet 
	mov	dpl,r6
	mov	dph,r7
	mov	dpx,r0
	mov	b,r1
	lcall	__gptrget
;	genMod 
;	DS80C390 div bug: rearranged ops.
; Peephole 105   removed redundant mov
	mov  r6,a
	mov	b,#0x0A
	div	ab
	mov	r7,b
;	genDiv 
;	DS80C390 div bug: rearranged ops.
	mov	a,r6
	mov	b,#0x0A
	div	ab
;	genLeftShift 
;	genLeftShiftLiteral (4), size 1
;	genlshOne 
; Peephole 105   removed redundant mov
	mov  r6,a
	swap	a
	anl	a,#0xF0
;	genPlus 
; Peephole 105   removed redundant mov
	mov  r6,a
	add	a,r7
;	genPointerSet 
; Peephole 100   removed redundant mov
	mov  r7,a
	mov  dptr,#(_RtcWrite_rtcBytes_1_1 + 0x0002)
	movx @dptr,a
;	rtc390.c:96: rtcBytes[1]=INTtoBCD(rtcDate->tm_sec);
;	genPointerGet 
;	genGenPointerGet 
	mov	dpl,r2
	mov	dph,r3
	mov	dpx,r4
	mov	b,r5
	lcall	__gptrget
;	genMod 
;	DS80C390 div bug: rearranged ops.
; Peephole 105   removed redundant mov
	mov  r2,a
	mov	b,#0x0A
	div	ab
	mov	r3,b
;	genDiv 
;	DS80C390 div bug: rearranged ops.
	mov	a,r2
	mov	b,#0x0A
	div	ab
;	genLeftShift 
;	genLeftShiftLiteral (4), size 1
;	genlshOne 
; Peephole 105   removed redundant mov
	mov  r2,a
	swap	a
	anl	a,#0xF0
;	genPlus 
; Peephole 105   removed redundant mov
	mov  r2,a
	add	a,r3
;	genPointerSet 
; Peephole 100   removed redundant mov
	mov  r3,a
	mov  dptr,#(_RtcWrite_rtcBytes_1_1 + 0x0001)
	movx @dptr,a
;	rtc390.c:98: rtcBytes[0]=0;
;	genPointerSet 
	mov	dptr,#_RtcWrite_rtcBytes_1_1
; Peephole 180   changed mov to clr
	clr  a
	movx	@dptr,a
;	rtc390.c:100: RtcSync();
;	genCall 
	lcall	_RtcSync
;	rtc390.c:102: for (byte=0; byte<8; byte++) {
;	genAssign 
;	genAssign: resultIsFar = FALSE
	mov	r2,#0x00
;	genLabel 
00105$:
;	genCmpLt 
;	genCmp
	cjne	r2,#0x08,00118$
00118$:
;	genIfxJump
; Peephole 108   removed ljmp by inverse jump logic
	jnc  00109$
00119$:
;	rtc390.c:103: for (bitMask=0x01; bitMask; bitMask<<=1) {
;	genAssign 
;	genAssign: resultIsFar = TRUE
	mov	r3,#0x01
;	genPlus 
	mov	a,r2
	add	a,#_RtcWrite_rtcBytes_1_1
	mov	dpl,a
; Peephole 3.d   changed mov to clr
	clr	a
	addc	a,#(_RtcWrite_rtcBytes_1_1 >> 8)
	mov	dph,a
; Peephole 3.d   changed mov to clr
	clr	a
	addc	a,#(_RtcWrite_rtcBytes_1_1 >> 16)
	mov	dpx,a
;	genPointerGet 
;	genFarPointerGet
	movx	a,@dptr
	mov	r4,a
;	genLabel 
00101$:
;	genIfx 
	mov	a,r3
;	genIfxJump
; Peephole 110   removed ljmp by inverse jump logic
	jz  00107$
00120$:
;	rtc390.c:104: rtc = (rtcBytes[byte]&bitMask) ? 0xff : 0x00;
;	genAnd 
	mov	a,r4
	anl	a,r3
;	genIfx 
;	genIfxJump
; Peephole 110   removed ljmp by inverse jump logic
	jz  00111$
00121$:
;	genAssign 
;	genAssign: resultIsFar = FALSE
	mov	r5,#0xFF
;	genGoto 
;	genLabel 
; Peephole 132   changed ljmp to sjmp
	sjmp 00112$
00111$:
;	genAssign 
;	genAssign: resultIsFar = FALSE
	mov	r5,#0x00
;	genLabel 
00112$:
;	genAssign 
;	genAssign: resultIsFar = TRUE
	mov	dptr,#_rtc
	mov	a,r5
	movx	@dptr,a
;	rtc390.c:103: for (bitMask=0x01; bitMask; bitMask<<=1) {
;	genLeftShift 
;	genLeftShiftLiteral (1), size 1
;	genlshOne 
	mov	a,r3
	add	a,acc
	mov	r5,a
;	genAssign 
;	genAssign: resultIsFar = TRUE
	mov	ar3,r5
;	genGoto 
;	genLabel 
; Peephole 132   changed ljmp to sjmp
	sjmp 00101$
00107$:
;	rtc390.c:102: for (byte=0; byte<8; byte++) {
;	genPlus 
	inc	r2
;	did genPlusIncr
;	genGoto 
;	genLabel 
; Peephole 132   changed ljmp to sjmp
	sjmp 00105$
00109$:
;	genEndFunction 
	ret
	.area CSEG    (CODE)
_rtcMagic:
	.db #0xC5
	.db #0x3A
	.db #0xA3
	.db #0x5C
	.db #0xC5
	.db #0x3A
	.db #0xA3
	.db #0x5C
	.area XINIT   (CODE)
